/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Message-area reading commands                                          *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <dos.h>
#include <string.h>
#include <mem.h>
#include "prog.h"
#include "alc.h"
#include "rep.h"
#include "max.h"
#include "max_msg.h"

extern int far pascal IsValidMsgArea(struct _area *a,int areanum);


int pascal Msg_Next(int startmsg)
{
  struct _msg msg;

  int msgfile,
      break_loop,
      x;

  char temp[PATHLEN];

  direction=DIRECTION_next;
  break_loop=FALSE;

  for (x=0;x < num_msg;x++)
  {
    if (msgs[x] > startmsg)
    {
      sprintf(temp,d_msg,msgs[x]);

      if ((msgfile=shopen(temp,O_RDWR | O_BINARY)) != -1)
      {
        break_loop=FALSE;

        if (read(msgfile,(char *)&msg,sizeof(struct _msg))==sizeof(struct _msg) &&
            CanSeeMsg(&msg))
        {
          Puts(CLS);
          Msg_Display(msgfile,&msg,usr.more,usr.msg,msgs[x],0);
          Recd_Msg(msgfile,&msg,msgs[x],-1);

          last_msg=msgs[x];
          break_loop=TRUE;

          close(msgfile);

          if ((eqstri(msg.to,usr.name) ||
               (eqstri(msg.from,usr.name) && (msg.attr & MSGREAD))) &&
              Ask_KillMsg(&msg))
            Msg_Kill(msgs[x]);
        }
        else
        {
          close(msgfile);
          Mdm_check(); /* Make sure user didn't drop carrier */
        }

        if (break_loop)
          break;
      }
    }
  }

  if (x==num_msg && !break_loop)
  {
    if (last_msg < high_msg)
      last_msg=high_msg;  /* last_msg++; */

    Printf(endavailmsg,(area.attrib[class] & NOPRIVATE) ? blank_str :
                                                          remain_pvt);
    Clear_KBuffer();

    /* We dump input here because new users (who aren't used to            *
     * Maximus/Opus-style message bases) may go whacking return when there *
     * is even a slight pause.  Inserting this command should make sure    *
     * we don't get into a long loop, searching for the last message.      */

    mdm_dump(DUMP_input);

    return -1;
  }

  return 0;
}

int pascal Msg_Previous(int startmsg)
{
  struct _msg msg;

  int msgfile,
      break_loop,
      x;

  char temp[PATHLEN];

  direction=DIRECTION_previous;
  break_loop=FALSE;

  for (x=num_msg-1;x >= 0;x--)
  {
    if (msgs[x] < startmsg)
    {
      sprintf(temp,d_msg,msgs[x]);

      if ((msgfile=shopen(temp,O_RDWR | O_BINARY)) != -1)
      {
        break_loop=FALSE;

        if (read(msgfile,(char *)&msg,sizeof(struct _msg))==sizeof(struct _msg) &&
            CanSeeMsg(&msg))
        {
          Puts(CLS);
          Msg_Display(msgfile,&msg,usr.more,usr.msg,msgs[x],0);
          Recd_Msg(msgfile,&msg,msgs[x],-1);

          last_msg=msgs[x];
          break_loop=TRUE;

          close(msgfile);

          if ((eqstri(msg.to,usr.name) ||
               (eqstri(msg.from,usr.name) && (msg.attr & MSGREAD))) &&
              Ask_KillMsg(&msg))
            Msg_Kill(msgs[x]);
        }
        else
        {
          close(msgfile);
          Mdm_check();
        }

        if (break_loop)
          break;
      }
    }
  }

  if (x==-1 && !break_loop)
  {
    if (last_msg > 0)
      last_msg=0;     /* last_msg--; */

    Printf(endavailmsg,(area.attrib[class] & NOPRIVATE) ? blank_str :
                                                          remain_pvt);
    Clear_KBuffer();

    /* We dump input here because new users (who aren't used to            *
     * Maximus/Opus-style message bases) may go whacking return when there *
     * is even a slight pause.  Inserting this command should make sure    *
     * we don't get into a long loop, searching for the last message.      */

    mdm_dump(DUMP_input);

    return -1;
  }

  return 0;
}



int pascal Msg_Nonstop(void)
{
  struct _msg msg;

  int msgfile,
      x,y;

  char temp[PATHLEN];

  Clear_KBuffer();

  y=0;

  Puts(CLS);
  Printf(message_name,s(msgar_name),Area_Name(usr.msg),area.msginfo);
  Putc('\n');

  if (direction==DIRECTION_next)
    x=0;
  else x=num_msg-1;

  while (1)
  {
    if (direction==DIRECTION_next && x >= num_msg)
      break;
    else if (direction==DIRECTION_previous && x < 0)
      break;

    if ((direction==DIRECTION_next && msgs[x] > last_msg) ||
        (direction==DIRECTION_previous && msgs[x] < last_msg))
    {
      sprintf(temp,d_msg,msgs[x]);

      if ((msgfile=shopen(temp,O_RDWR | O_BINARY)) != -1)
      {
        last_msg=msgs[x];

        if (read(msgfile,(char *)&msg,sizeof(struct _msg))==sizeof(struct _msg) &&
            CanSeeMsg(&msg))
        {
          y=Msg_Display(msgfile,&msg,FALSE,usr.msg,msgs[x],0);
          Recd_Msg(msgfile,&msg,msgs[x],-1);
          last_msg=msgs[x];

          Puts(n_n);
        }

        close(msgfile);

        /* Do a flush, so we don't get too far ahead of user! */

        if (y==-1 || Mdm_flush_ck() || brk_trapped || mdm_halt())
        {
          brk_trapped=0;
          mdm_dump(DUMP_all);
          last_msg=msgs[x];
          return -1;
        }
      }
    }

    if (direction==DIRECTION_next)
      x++;
    else x--;
  }

  return 0;
}



int pascal Msg_Read_Reply(void)
{
  struct _msg msg;
  char temp[PATHLEN];

  int msgfile,
      x;

  sprintf(temp,d_msg,last_msg);

  if ((msgfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
  {
    x=read(msgfile,(char *)&msg,sizeof(struct _msg));
    close(msgfile);

    if (x==sizeof(struct _msg) && msg.up && CanSeeMsg(&msg))
    {
      sprintf(temp,d_msg,msg.up);

      if (fexist(temp))
        return (Msg_Next(msg.up-1));
      else Puts(msgnotavail);
    }
    else Puts(msgnotavail);
  }

  return -1;
}



int pascal Msg_Read_Original(void)
{
  struct _msg msg;
  char temp[PATHLEN];

  int msgfile,
      x;

  sprintf(temp,d_msg,last_msg);

  if ((msgfile=shopen(temp,O_RDONLY | O_BINARY)) != -1)
  {
    x=read(msgfile,(char *)&msg,sizeof(struct _msg));
    close(msgfile);

    if (x==sizeof(struct _msg) && msg.reply && CanSeeMsg(&msg))
    {
      sprintf(temp,d_msg,msg.reply);

      if (fexist(temp))
        return (Msg_Next(msg.reply-1));
      else Puts(msgnotavail);
    }
    else Puts(msgnotavail);
  }

  return -1;
}



int pascal Msg_Read_Individual(int ch)
{
  char temp[PATHLEN];

  int msgnum;

  if (! isdigit(ch))
    ch='0';

  if (hotkeys(usr) && isnl(linebuf))
  {
    if (usr.help==HOTFLASH)
    {
      WhiteN();
      OpusGetsC(temp,ch,s(msgn_prompt));
    }
    else OpusGetsC(temp,ch,blank_str); /* else std hotkey, no hotflash */

    if (isdigit(*temp))
      msgnum=atoi(temp);
    else
    {
      strcpy(linebuf,temp);
      return -1;
    }
  }
  else
  {
    memmove(linebuf+1,linebuf,strlen(linebuf)+1);
    *linebuf=(char)ch;
    msgnum=atoi(linebuf);
  }

  mknl(linebuf);

  if (msgnum != 0)
  {
    if (direction==DIRECTION_next)
      return (Msg_Next(msgnum-1));
    else return (Msg_Previous(msgnum+1));
  }

  return -1;
}




int pascal Goodbye_Comment(void)
{
  extern int linenum;

  struct _msg msg;

  int aborted,
      u_msg,
      x;

  mknl(areatag);

  u_msg=usr.msg;

  last=MENU_other;
  infilearea=FALSE;

  /* Make sure the area exists */

  if (Read_Area(&area,usr.msg=Set_Area_Name(zero))==-1)    
  {
    usr.msg=u_msg;
    return FALSE;
  }

  /* Make sure there's a message path */

  if (isblstr(area.msgpath) || !direxist(area.msgpath))
  {
    usr.msg=u_msg;
    return FALSE;
  }

  if (Last_Msg()==-1)   /* Make sure we can change to it */
  {
    usr.msg=u_msg;
    return FALSE;
  }

  /* Now prepare the message for a log-off comment */

  Blank_Msg(&msg);

  zoneto=prm.address[0].Zone;
  pointto=0;

  strcpy(msg.from,usr.name);
  strcpy(msg.to,PRM(sysop));
  sprintf(msg.subj,s(comment_fr),usr.name);

  /* If we can have pvt. msgs in this area */

  if (! (area.attrib[class] & NOPRIVATE)) 
    msg.attr |= MSGPRIVATE; /* Then set MSGPRIVATE on by default */

  if (usr.use_lore)
    Printf(s(inrefto),msg.subj);

  logit(usingeditor);
  x=Editor(&msg,-1);
  logit(outofeditor);

  if (x != ABORT)
  {
    if (x==LOCAL_EDIT)
      aborted=FALSE;
    else
    {
      /* If nothing entered */
      if ((last_maxed ? num_lines : linenum)==1 && !screen[1][1])  
      {
        Free_All();
        aborted=TRUE;
      }
      else
      {
        /* Make sure that user didn't readdress msg to someone else,       *
         * through the BORED menu.                                         */

        strcpy(msg.to,PRM(sysop));
        aborted=Save_Msg(&msg,NULL,FALSE,0,0);
      }
    }
  }
  else aborted=TRUE;

  if (aborted)
    Puts(msg_aborted);

  Restore_Directories();

  sfree(msgs);

  inmsgarea=FALSE;

  usr.msg=u_msg;

  Last_Other();
  
  if (aborted)
    return FALSE;
  else return TRUE;
}



/***************************************************************************
                             End of Menu Options
 ***************************************************************************/


void pascal Press_ENTER_Read(void)
{
  char string[BUFLEN];

  Puts(WHITE);
  Input(string,INPUT_nlb_line | INPUT_msgread,0,BUFLEN,press_enter);
  display_line=1;
  keepflag=FALSE;
}

int pascal MoreYnns_Read(void)
{
  int c;

  c=GetYnnsAnswer(more,CINPUT_nolf | CINPUT_msgread);

  if (usr.help != HOTFLASH)
  {
    if (graph==GRAPHICS_none)
      Puts(moreynns_blank);
    else Puts(CLEOL);
  }

  keepflag=FALSE;
  return c;
}


int pascal Last_Msg_Overlay(void)
{
  struct _area sys;

  entry=ENTRY_false;

  if (infilearea)   /* So if we're in file area (say) 6, and we enter    */
    usr.msg=usr.files;/* a MESSAGE cmd, the msg. area gets flipped to 6,   */
                    /* too, so our user doesn't get confused.            */

  /* Read the area, and set the area's PRIV level to TWIT, so we can all *
   * access it to leave log-off comments!                                */

  sys.areano=usr.msg;

  if (Read_Area(&sys,usr.msg)==-1 ||
      (sys.msgpriv=TWIT, ! IsValidMsgArea(&sys,0)))
  {
    You_Cant_Get_There();
    return -1;
  }
  else
  {
    IsValidMsgArea(NULL,usr.msg);

    if (Save_Directory(area.msgpath)==-1)
    {
      You_Cant_Get_There();
      return -1;
    }
    else
    {
      if (msgs==NULL && (msgs=(int *)malloc(sizeof(int)*MAX_MSG))==NULL)
      {
        logit(mem_nmsga);
        You_Cant_Get_There();
        return -1;
      }

      Msg_Area_Tag();
      Msg_Area_Scan();

      last=MENU_msg;
      inmsgarea=TRUE;
      infilearea=FALSE;
    }
  }

  return 0;
}


#ifdef __TURBOC__
long verylongtime(struct _stamp *sc)
{
  struct date date;
  struct time time;
  date.da_year=((union stamp_combo *)sc)->msg_st.date.yr+1980;
  date.da_day= ((union stamp_combo *)sc)->msg_st.date.da;
  date.da_mon= ((union stamp_combo *)sc)->msg_st.date.mo;

  time.ti_min= ((union stamp_combo *)sc)->msg_st.time.mm;
  time.ti_hour=((union stamp_combo *)sc)->msg_st.time.hh;
  time.ti_sec= ((union stamp_combo *)sc)->msg_st.time.ss << 1;
  time.ti_hund=0;
  return(dostounix(&date,&time));  /* dostounix is a turboc function */

}
#else  /* assume MSC */
long verylongtime(struct _stamp *sc)
{
    struct tm t;

    t.tm_sec   = sc->time.ss * 2; /* seconds after the minute - [0, 59] */
    t.tm_min   = sc->time.mm ;   /* minutes after the hour - [0, 59]   */
    t.tm_hour  = sc->time.hh ;   /* hours since midnight - [0, 23]     */
    t.tm_mday  = sc->date.da ;   /* day of the month - [1, 31]         */
    t.tm_mon   = sc->date.mo ;   /* months since January - [0, 11]     */
    t.tm_year  = sc->date.yr+80; /* years since 1900                   */
    t.tm_isdst = 0;
    return(mktime(&t));

}
#endif


int pascal Header_Message(int entry)
{
  char temp[PATHLEN];

  int usrpriv,
      nochke;
    
  nochke=FALSE;
    
  if (entry==ENTRY_nochecke)
  {
    entry=ENTRY_nocheck;
    nochke=TRUE;
  }

  if (entry==ENTRY_nohdr && inmsgarea)
    return TRUE;

  if (entry==ENTRY_nohdre)
    entry=ENTRY_nohdr;

  if (entry==ENTRY_true || entry==ENTRY_noheader || entry==ENTRY_nocheck || entry==ENTRY_nohdr)
  {
    if (entry != ENTRY_nocheck)
    {
      if (!barricade_ok)
      {
        Undo_Barricade();

        if (! IsValidMsgArea(NULL,usr.msg))   /* Read SYSTEMxx and see if it's valid */
          usrpriv=Msg_Area();

        if (*area.msgbar)
        {
          Barricade(TRUE);

          if (barricade_ok)
            usrpriv=barricade_priv;
          else usrpriv=Msg_Area();
        }
        else
        {
          usrpriv=usr.priv;
          barricade_ok=TRUE;
        }

        if (*area.msgbar && !barricade_ok)
          usrpriv=Msg_Area();

        Redo_Barricade(usrpriv);
      }
    }

    if (Save_Directory(area.msgpath)==-1)
    {
      logit(mem_ndir);
      Puts(mem_ndir);
      return FALSE;
    }

    direction=DIRECTION_next;

    if (! *linebuf && entry != ENTRY_noheader && entry != ENTRY_nohdr &&
        (entry != ENTRY_nocheck || nochke) && !restart_system)
      Puts(s(msg_sect));

    if (msgs==NULL && (msgs=(int *)malloc(sizeof(int)*MAX_MSG))==NULL)
    {
      logit(mem_nmsga);
      return FALSE;
    }

    last=MENU_msg;

    Msg_Area_Scan();
    inmsgarea=TRUE;
    infilearea=FALSE;

    if (! *linebuf && entry != ENTRY_noheader && entry != ENTRY_nohdr &&
        (entry != ENTRY_nocheck || nochke) && !restart_system)
    {
      if (num_msg==0)
        Puts(s(msg_none));
      else
      {
        Printf(s(msg_inarea),num_msg,high_msg);

        if (last_msg==0)
          Puts(s(msg_noread));
        else if (last_msg >= high_msg)
          Puts(s(msg_nonew));
        else Printf(s(msg_lmsg),last_msg);
      }

      Puts(n_n);

      if (last_msg==0)
        sprintf(temp,"%sDESCRIPT.?BS",area.msgpath);

      if (fexist(temp))
      {
        *strrchr(temp,'.')='\0';
        Display_File(0,NULL,temp);
      }
    }
  }

  if ((entry==ENTRY_false || entry==ENTRY_noheader || restart_system) &&
      entry != ENTRY_nohdr && entry != ENTRY_nocheck && ! *linebuf)
  {
    Printf(s(msg_ban1),
           last_msg,
           high_msg,
           usr.help==NOVICE ? s(msg_ban2) :
                              ((usr.help==REGULAR || usr.help==HOTFLASH) ?
                              s(msg_ban3) :
                              s(msg_ban4)),
           direction ? s(nxt) : s(prr),
           usr.help==NOVICE ? s(msg_ban5) : blank_str);
  }

  if (! *linebuf && entry != ENTRY_nohdr &&
      (entry != ENTRY_nocheck || nochke) && !restart_system)
  {
    Printf(message_name,(area.attrib[class] & SYSMAIL) ? s(mtrx) :
           ((area.attrib[class] & ECHOMAIL) ? s(s_echo) : s(s_msg)),
           Area_Name(usr.msg),area.msginfo);

    Putc('\n');
  }
  
  restart_system=FALSE;
  return TRUE;
}



